/*******************************************************************************
This software module was originally developed by

Dolby Laboratories, Fraunhofer IIS, VoiceAge Corp.


Initial author:
Nikolaus Rettelbach     (Fraunhofer IIS)
Frederik Nagel          (Fraunhofer IIS)

and edited by:

-

in the course of development of ISO/IEC 23003 for reference purposes and its
performance may not have been optimized. This software module is an
implementation of one or more tools as specified by ISO/IEC 23003. ISO/IEC gives
You a royalty-free, worldwide, non-exclusive, copyright license to copy,
distribute, and make derivative works of this software module or modifications
thereof for use in implementations of ISO/IEC 23003 in products that satisfy
conformance criteria (if any). Those intending to use this software module in
products are advised that its use may infringe existing patents. ISO/IEC have no
liability for use of this software module or modifications thereof. Copyright is
not released for products that do not conform to audiovisual and image-coding
related ITU Recommendations and/or ISO/IEC International Standards.

Assurance that the originally developed software module can be used (1) in
ISO/IEC 23003 once ISO/IEC 23003 has been adopted; and (2) to develop ISO/IEC
23003:s
Fraunhofer IIS, VoiceAge Corp. grant(s) ISO/IEC all
rights necessary to include the originally developed software module or
modifications thereof in ISO/IEC 23003 and to permit ISO/IEC to offer You a
royalty-free, worldwide, non-exclusive, copyright license to copy, distribute,
and make derivative works for use in implementations of ISO/IEC 23003 in
products that satisfy conformance criteria (if any), and to the extent that such
originally developed software module or portions of it are included in ISO/IEC
23003. To the extent that Fraunhofer IIS, VoiceAge Corp.
own(s) patent rights that would be required to make, use, or sell the
originally developed software module or portions thereof included in ISO/IEC
23003 in a conforming product, Fraunhofer IIS, VoiceAge Corp. 
will assure the ISO/IEC that it is (they are) willing to negotiate
licenses under reasonable and non-discriminatory terms and conditions with
applicants throughout the world. ISO/IEC gives You a free license to this
software module or modifications thereof for the sole purpose of developing
ISO/IEC 23003.

Fraunhofer IIS, VoiceAge Corp. retain full right to
modify and use the code for its (their) own purpose, assign or donate the code
to a third party and to inhibit third parties from using the code for products
that do not conform to MPEG-related ITU Recommendations and/or ISO/IEC
International Standards. This copyright notice must be included in all copies or
derivative works.

Copyright (c) ISO/IEC 2008.
$Id: harmsbrPhasevoc.h,v 1.8 2011-03-06 20:50:37 mul Exp $
*******************************************************************************/
#ifndef _PHASEVOC_H_
#define _PHASEVOC_H_

#include "harmsbr.h"

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

void 
PhaseVocoderApply(HANDLE_HBE_TRANSPOSER hPhaseVocoder,
                  float                 qmfBufferCodecReal[][64],
                  float                 qmfBufferCodecImag[][64],
                  int                   nColsIn,
                  float                 qmfBufferPVReal[][64],
                  float                 qmfBufferPVImag[][64],
                  int                   bOverSampling,
                  int                   pitchInBins);

int
PhaseVocoderCreate(HANDLE_HBE_TRANSPOSER *hPhaseVocoder,
                   const int frameSize,            /* Analysis FFT length */
                   int bSbr41);


void
PhaseVocoderReInit(HANDLE_HBE_TRANSPOSER hPhaseVocoder,
                   int FreqBandTable[2][MAX_FREQ_COEFFS + 1],
                   int  NSfb[2],
                   int bSbr41);

void
PhaseVocoderClose(HANDLE_HBE_TRANSPOSER hPhaseVocoder);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* #ifndef _PHASEVOC_H_  */
